/*
 *   MIRACL flash random number routine 
 *   mrfrnd.c
 *
 *   Copyright (c) 1988-1997 Shamus Software Ltd.
 */

#include <stdio.h>
#include <miracl.h>

extern miracl *mr_mip;

#ifdef MR_FLASH

void frand(flash x)
{ /* generates random flash number 0<x<1 */
    int i;
    if (mr_mip->ERNUM) return;

    MR_IN(46)

    zero(mr_mip->w6);
    mr_mip->w6[0]=mr_mip->nib;
    for (i=1;i<=mr_mip->nib;i++) 
    { /* generate a full width random number */
        if (mr_mip->base==0) mr_mip->w6[i]=brand();
        else                 mr_mip->w6[i]=brand()%mr_mip->base;
    }
    mr_mip->check=OFF;
    bigrand(mr_mip->w6,mr_mip->w5);
    mr_mip->check=ON;
    round(mr_mip->w5,mr_mip->w6,x);

    MR_OUT
}

#endif

